using System;
using System.Runtime.InteropServices;
using PkmnLibSharp.StaticData;

namespace PkmnLibSharp.FFI.StaticData
{
    internal static class Form
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr form_new(IntPtr name, float height, float weight, uint baseExperience,
            IntPtr types, ulong typesLength, IntPtr baseStats, IntPtr abilities, ulong abilitiesLength,
            IntPtr hiddenAbilities, ulong hiddenAbilitiesLength, IntPtr learnableMoves, IntPtr flags,
            ulong flagsLength);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern void form_drop(IntPtr ptr);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr form_name(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern float form_height(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern float form_weight(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern uint form_base_experience(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern ulong form_types_length(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern TypeIdentifier form_types_get(IntPtr ptr, ulong index);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr form_base_stats(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern ulong form_abilities_length(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr form_abilities_get(IntPtr ptr, ulong index);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern ulong form_hidden_abilities_length(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr form_hidden_abilities_get(IntPtr ptr, ulong index);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr form_moves(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern byte form_has_flag(IntPtr ptr, IntPtr flag);
    }
}