using System;
using System.Runtime.InteropServices;
using PkmnLibSharp.StaticData;

namespace PkmnLibSharp.FFI.StaticData
{
    internal static class StaticStatisticSet
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr static_statistic_set_u8_new(byte hp, byte attack, byte defense,
            byte specialAttack, byte specialDefense, byte speed);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr static_statistic_set_u16_new(ushort hp, ushort attack, ushort defense,
            ushort specialAttack, ushort specialDefense, ushort speed);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr static_statistic_set_u32_new(uint hp, uint attack, uint defense,
            uint specialAttack, uint specialDefense, uint speed);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr static_statistic_set_i8_new(sbyte hp, sbyte attack, sbyte defense,
            sbyte specialAttack, sbyte specialDefense, sbyte speed);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr static_statistic_set_i16_new(short hp, short attack, short defense,
            short specialAttack, short specialDefense, short speed);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr static_statistic_set_i32_new(int hp, int attack, int defense, int specialAttack,
            int specialDefense, int speed);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void static_statistic_set_u8_drop(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void static_statistic_set_u16_drop(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void static_statistic_set_u32_drop(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void static_statistic_set_i8_drop(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void static_statistic_set_i16_drop(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void static_statistic_set_i32_drop(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern byte static_statistic_set_u8_get_stat(IntPtr value, Statistic statistic);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern ushort static_statistic_set_u16_get_stat(IntPtr value, Statistic statistic);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern uint static_statistic_set_u32_get_stat(IntPtr value, Statistic statistic);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern sbyte static_statistic_set_i8_get_stat(IntPtr value, Statistic statistic);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern short static_statistic_set_i16_get_stat(IntPtr value, Statistic statistic);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern int static_statistic_set_i32_get_stat(IntPtr value, Statistic statistic);
    }
}